# prepare source: mkdir -p /rpm/SOURCES/v4l2loopback, open terminal there
# git clone https://github.com/umlaeute/v4l2loopback.git
# rename with version to v4l2loopback-0.12.1
# move dkms.conf, v4l2loopback.c, v4l2loopback_formats.h and
# v4l2loopback-dkms-Makefile as Makefile to new folder src ;
# move v4l2loopback-util-Makefile as Makefile to the archive folder;
# Source1:		v4l2loopback-dkms-Makefile
# Source2:		v4l2loopback-util-Makefile
# ### above old stuff ##########################################################
%define pname v4l2loopback

Name:           dkms-%{pname}
Version:        0.13.0
Release:        %mkrel 1
Summary:        A kernel module to create V4L2 loopback devices
License:        GPL-2.0+
Group:          System/Kernel and hardware
Url:            https://github.com/umlaeute/v4l2loopback/archive/v%{version}.tar.xz
Source0:        %{pname}-%{version}.tar.xz
Source1:		v4l2loopback-0.12.7-dkms-pclos-Makefile
Source2:		60-persistent-v4l2loopback.rules
# older Source1:        v4l2loopback-dkms-pclos-Makefile
# in new source version
#Patch0:			v4l2loopback.c-0.12.5-adds.patch

BuildRequires:  gcc
BuildRequires:  help2man
BuildRequires:  make

Requires:       v4l-utils-qt5
Requires:		help2man
Requires:		dkms
Requires:		dkms-minimal
Requires:		%{pname}-utils
Requires(post):		dkms
Requires(preun):	dkms
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

Provides:	%{name} = %{version}
Provides:	kmod(%{pname}.ko) = %{version}

%description
This module allows you to create "virtual video devices".
Normal (v4l2) applications will read these devices as if they were ordinary
video devices, but the video will not be read from e.g. a capture card but
instead it is generated by another application.
This allows you for instance to apply some nifty video effects on
your Skype video...
It also allows some more serious things (e.g. I've been using it to add
streaming capabilities to an application by the means of hooking GStreamer
into the loopback devices).


%package -n %{pname}-utils
Summary:	v4l2loopback-ctl for controlling FPS, placeholder image and image format
Group:      System/Kernel and hardware
Provides:	%{pname}-ctl
Provides:	%{pname}-ctl.1.bz2
Requires:	man
Requires:	v4l-utils-qt5
Requires:	%{name}

%description -n %{pname}-utils
Use v4l2loopback-ctl for controlling FPS, placeholder image and image format.
See "$ man v4l2loopback-ctl.1" or "$ v4l2loopback-ctl --help".
Also the README.md is a good startup.(gstreamer-1.0)

%prep
%setup -q -n %{pname}-%{version}

%autopatch -p1


%install
%__rm -rf %{buildroot}

# make util and man
%__install -p -dm 755 %{buildroot}%{_bindir}
%__install -p -dm 755 %{buildroot}%{_mandir}/man1
%__make install-utils install-man DESTDIR=%{buildroot} PREFIX=%{_prefix} BINDIR=%{_bindir} MANDIR=%{_mandir}
%__tar -cvjf %{buildroot}%{_mandir}/man1/v4l2loopback-ctl.1.bz2 %{_builddir}/v4l2loopback-%{version}/man/v4l2loopback-ctl.1
%__rm -rf %{buildroot}%{_mandir}/man1/v4l2loopback-ctl.1
%__rm -rf %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/man

# inst udev-rule + set all users are member of group video
%__install -p -Dm 644 %{S:2} %{buildroot}/lib/udev/rules.d/60-persistent-v4l2loopback.rules
# install %{_sysconfdir}/modprobe.d/%{pname}.conf
%__install -p -dm 755 %{buildroot}%{_sysconfdir}/modprobe.d
%__cat <<EOF > %{buildroot}%{_sysconfdir}/modprobe.d/%{pname}.conf
options v4l2loopback devices=4 exclusive_caps=1
EOF

#make dkms
%__mkdir -p %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
%__install %{S:1} %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/Makefile
%__install v4l2loopback.c %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
%__install v4l2loopback_formats.h %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
%__install v4l2loopback.h %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
%__rm -rf %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/dkms.conf
%__cat <<EOF > %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/dkms.conf
PACKAGE_NAME="%{pname}"
PACKAGE_VERSION="%{version}-%{release}"
CLEAN="make clean"
MAKE="export IGNORE_CC_MISMATCH=1; 'make' clean KSRC=\${kernel_source_dir} SKIP_STACK_VALIDATION=1 all"
BUILT_MODULE_NAME[0]="%{pname}"
DEST_MODULE_LOCATION[0]="/kernel/3rdparty/%{pname}"
AUTOINSTALL="yes"
CLEAN="'make' clean"
EOF

%post -n %{name}
/usr/sbin/dkms --rpm_safe_upgrade add -m %{pname} -v %{version}-%{release} &&
/usr/sbin/dkms --rpm_safe_upgrade build -m %{pname} -v %{version}-%{release} &&
/usr/sbin/dkms --rpm_safe_upgrade install -m %{pname} -v %{version}-%{release}

/sbin/modprobe -r %{pname}  >/dev/null 2>&1 ||:
/sbin/modprobe videodev  >/dev/null 2>&1 ||:
/sbin/modprobe %{pname}  >/dev/null 2>&1 ||:


%preun -n %{name}
rm -rf %{_mandir}/man1/v4l2loopback-ctl.1*
# rmmod can fail
/sbin/rmmod %{pname} >/dev/null 2>&1 ||:
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{pname} -v %{version}-%{release} --all || :


%clean
rm -rf %{buildroot}

%files -n %{name}
%defattr(-,root,root)
%{_usrsrc}/%{pname}-%{version}-%{release}/*
%config(noreplace) /lib/udev/rules.d/60-persistent-v4l2loopback.rules
%config(noreplace) %{_sysconfdir}/modprobe.d/%{pname}.conf

%files -n %{pname}-utils
%defattr(-,root,root)
%doc README.md AUTHORS ChangeLog COPYING TODO NEWS
%{_bindir}/v4l2loopback-ctl
%{_mandir}/man1/v4l2loopback-ctl.1.bz2


%changelog
* Tue Mar 19 2024 onkelho <oh.quait at gmail.com> - 0.13.0-1quait2024
- new version released on 1 hour ago
- * Dynamic device management

* Tue Feb 13 2024 onkelho <oh.quait at gmail.com> - 0.12.7-8quait2024
- rebuild updates  
- supports build on kernels upto 6.8
- From https://github.com/umlaeute/v4l2loopback
-    fb410fc..5d72c17  main       -> origin/main
-    a1db46c..e0cd3bb  develop    -> origin/develop
- Updating fb410fc..5d72c17
- Fast-forward
-  .github/ISSUE_TEMPLATE/config.yml               |   3 +
-  .github/workflows/kmod-compatibility-checks.yml |  36 +-
-  .gitignore                                      |   2 +
-  Makefile                                        |  54 +-
-  README.md                                       |  13 +-
-  tests/.gitignore                                |   7 +
-  tests/Makefile                                  |   4 +-
-  tests/checkformat.sh                            |  84 +++
-  tests/common.h                                  | 154 +++++
-  tests/consumer.c                                | 632 ++++++++++++++++++++
-  tests/producer.c                                | 720 +++++++++++++++++++++++
-  tests/test_dqbuf.c                              | 153 ++---
-  utils/Makefile                                  |  14 +
-  utils/v4l2loopback-ctl.c                        | 729 ++++++++++++++++++------- 
-  v4l2loopback.c                                  | 681 +++++++++++++++-------
-  v4l2loopback.h                                  |  10 +-
-  16 files changed, 2812 insertions(+), 484 deletions(-)
-  create mode 100644 tests/.gitignore
-  create mode 100755 tests/checkformat.sh
-  create mode 100644 tests/common.h
-  create mode 100644 tests/consumer.c
-  create mode 100644 tests/producer.c

* Tue Jun 27 2023 tex - 0.12.7-7pclos2023
- fix rpm group

* Tue Apr 07 2023 onkelho <oh.quait at gmail.com> - 0.12.7-6pclos2023
- rebuild after testing situation on kernels updates,
- now FREE of "installed  (WARNING! Diff between built and installed module!)"
- 5.15.105 to 5.15.106
- and 6.2.9 to 6.2.10

* Tue Apr 04 2023 onkelho <oh.quait at gmail.com> - 0.12.7-4pclos2023
- rebuild 
- fixing "installed  (WARNING! Diff between built and installed module!)"
- - if e.g. installed on 6.2.8 and then upgrade kernel
- - to 6.2.9, but keep the older

* Thu Mar 30 2023 onkelho <oh.quait at gmail.com> - 0.12.7-3pclos2023
- rebuild 
- reverted: The issue is somewhere around this:
-    Reset V4L2_BUF_FLAG_MAPPED if use_count <= 0
-    Track active readers
-    Support V4L2_EVENT_PRI_CLIENT_USAGE
-    Fix signed integer overflows in increments.
-    v4l2loopback: a new offset for V4L2_EVENT_PRI_CLIENT_USAGE
-    Allow a minimum of 0 fps
- I've reverted these changes, and the playback doesn't freeze any more for me.


* Sat Mar 25 2023 onkelho <oh.quait at gmail.com> - 0.12.7-2pclos2023
- rebuild 
- updates - minor fixes

* Sun Sep 04 2022 onkelho <oh.quait at gmail.com> - 0.12.7-1pclos2022
- new version release
- v4l2loopback (0.12.7)
- [ IOhannes m zmölnig ]
- * Add explicit format specifier to printf() invocations
- [ Andreas Beckmann ]
- * REMAKE_INITRD is deprecated in dkms 3
- * Do not attempt to build modules for kernels without CONFIG_VIDEO_V4L2
- [ Dimitri John Ledkov ]
- * Fixup obsolete module init/exit
- [ You-Sheng Yang ]
- * dev: initialize per opener v4l2_fh
- * event: install event (un)subscribe hook
- * compliance: fix enum frame sizes/intervals errors
- * compliance: fix "fmtdesc.type was modified" error
- * UBUNTU: SAUCE: coverity: fix null pointer dereference
- [ Tim Gardner ]
- * Fix unchecked return value in vidioc_s_fmt_out()
- * Fix resource leak in v4l2_loopback_open()
- * Fix NULL dereference in free_buffers()
- [ Erich Eickmeyer ]
- * Don't fail if allocating 0-sized buffers
- -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>
- --    Wed, 05 Aug 2022 00:24:03 +0200
- onkelho - fix utils by add install(-utils)

* Sat Jun 11 2022 onkelho <oh.quait at gmail.com> - 0.12.5-6pclos2022
- rebuild - 

* Wed Jun 08 2022 onkelho <oh.quait at gmail.com> - 0.12.5-5pclos2022
- rebuild

* Mon Jun 06 2022 onkelho <oh.quait at gmail.com> - 0.12.5-4pclos2022
- rebuild
- add 60-persistent-v4l2loopback.rules
- fix execusion-format-error

* Mon Jan 31 2022 onkelho <oh.quait at gmail.com> - 0.12.5-3pclos2022
- updates 
- add export IGNORE_CC_MISMATCH=1;

* Sat Sep 04 2021 onkelho <oh.quait at gmail.com> - 0.12.5-2pclos2021
- updates

* Sun May 17 2020 onkelho <oh.quait at gmail.com> - 0.12.5-1pclos2020
- new version released
- add patch0
- - Set device_caps in init_vdev() for all kernel-versions (not just >4.7.0)
- - Don't set the V4L2_CAP_DEVICE_CAPS on device_caps
- - only set (struct video_device).device_caps on linux>=4.7.0
- - pre-processor directives should be left-aligned
- - tabify
- - Drop obsolete ISSUE_TEMPLATE
- - Mention that people should do research before creating a new ticket
- - document that we expect people to do some research before creating a …
- - document that people must have a proper bulid-environment

* Mon Apr 13 2020 onkelho <oh.quait at gmail.com> - 0.12.4-1pclos2020
- new version released
- Use v4l2_buffer ptr instead of timeval (Compat with linux-5.6)
- Add example that loops over YUV frames infinitely
- Document 'exclusive_caps' mode option (and some markdown fixes)
- Set the default number of buffers to 2
- Print "SUCCESS" message on installation success
- Drop cast to (time_t)
- Document 'exclusive_caps' mode option (and some more markdown fixes)

* Mon Mar 30 2020 onkelho <oh.quait at gmail.com> - 0.12.3-2pclos2020
- rebuild -- set default 2

* Sat Dec 14 2019 onkelho <oh.quait at gmail.com> - 0.12.3-1pclos2019
- new version release
- * Fixed compat with kernel 5.4

* Tue Jun 25 2019 onkelho <oh.quait at gmail.com> - 0.12.2-1pclos2019
- new rel
- fixes since v4l2loopback-0.12.1
- * Fixed compat with kernel 5.0
- * Replace v4l2_get_timestamp with ktime_get_ts(64) for linux-5.1 compat
-- IOhannes m zmölnig <zmoelnig@umlaeute.mur.at>  Mon, 02 Jul 2018 12:27:29 +0200

* Mon May 13 2019 onkelho <oh.quait at gmail.com> - 0.12.1-3pclos2019
- rebuild realy fixing see prepare source

* Sun May 12 2019 onkelho <oh.quait at gmail.com> - 0.12.1-2pclos2019
- rebuild fixed linux-5.1.1 
- Replace v4l2_get_timestamp with ktime_get_ts(64)
- -v4l2_get_timestamp is being removed in Linux 5.1. This replaces its use
- -with equivalent code (ktime_get_ts64 is used in favor of ktime_get_ts
- -with supported kernel versions, as the latter is considered deprecated).

* Mon Mar 11 2019 onkelho <oh.quait at gmail.com> 0.12.1-1pclos2018
- new ver-rel on 2019-23-01

* Fri Nov 09 2018 onkelho <oh.quait at gmail.com> 0.12.0-2pclos2018
- rebuild + last commites: 8-gd20c399
- - Fixed permission of source code files b388f46
- - initialize variables 57e20f2
- - use %u to print size_t bce4274
- - improved coding style by removing unused variables 5647eea
- - mroe coding style fixes a4f7139
- - Use GStreamer-1.0 caps in the documentation 0156144
- - gst1.0 compat for example-script 396f0f8
- - fix typo d20c399

* Sun Aug 19 2018 onkelho <oh.quait at gmail.com> 0.12.0-1pclos2018
- new version release
- -   * Fixed compat with kernel 4.16
  * NV12 support
  * 8bit Bayer support
- -- IOhannes m zmölnig <zmoelnig@umlaeute.mur.at> Mon, 02 Jul 2018 12:27:29 +0200

* Fri May 04 2018 onkelho <oh.quait at gmail.com> 0.11.0-2pclos2018
- rebuild --add SKIP_STACK_VALIDATION=1

* Tue Apr 10 2018 onkelho <oh.quait at gmail.com> 0.11.0-1pclos2018
- update new version release

* Mon Feb 19 2018 onkelho <oh.quait at gmail.com> 0.10.0-28pclos2018
- last

* Mon Feb 19 2018 onkelho <oh.quait at gmail.com> 0.10.0-27pclos2018
- better clean before reset package-version-count

* Sun Feb 18 2018 onkelho <oh.quait at gmail.com> 0.10.0-26pclos2018
- set back to 2 devices on module load

* Thu Feb 15 2018 onkelho <oh.quait at gmail.com> 0.10.0-24pclos2018
- repack

* Thu Feb 15 2018 onkelho <oh.quait at gmail.com> 0.10.0-22pclos2018
- modified make in src and dkms.conf 

* Thu Feb 15 2018 onkelho <oh.quait at gmail.com> 0.10.0-21pclos2018
- add dkms and minimal as requires 

* Wed Feb 14 2018 onkelho <oh.quait at gmail.com> 0.10.0-20pclos2018
- clean and add Require-dkms for utils
- add docs

* Wed Feb 14 2018 onkelho <oh.quait at gmail.com> 0.10.0-16pclos2018
- to check update dkms

* Wed Feb 14 2018 onkelho <oh.quait at gmail.com> 0.10.0-15pclos2018
- split pkg for clean dkms-src

* Mon Feb 12 2018 onkelho <oh.quait at gmail.com> 0.10.0-14pclos2018
- add require help2man -rebuild on 4.15.3

* Sun Feb 11 2018 onkelho <oh.quait at gmail.com> 0.10.0-10pclos2018
- rebuild makefile

* Sat Feb 10 2018 onkelho <oh.quait at gmail.com> 0.10.0-9pclos2018
- tar manpage to bz2 , modprobe

* Fri Feb 09 2018 onkelho <oh.quait at gmail.com> 0.10.0-7pclos2018
- don't splitt package, all in dkms
- build on kernel-4.15.2-pclos1

* Sun Nov 19 2017 onkelho <oh.quait at gmail.com> 0.10.0-2pclos2017
- update
